;##################################################
;##                                              ##
;##        [ Asm7x.List ][ IQSortS1.inc ]        ##
;##                                              ##
;##            -= Smart Quick Sort =-            ##
;##         (for single element arrays)          ##
;##                                              ##
;##             ஢           ##
;##    ( ᨢ  묨 ⠬)    ##
;##                                              ##
;##           [ v1.00 :: 11.11.2017 ]            ##
;##              MASM/TASM (16 bit)              ##
;##                                              ##
;##     (c) 2017 by Jin X (jin.x@sources.ru)     ##
;##             http://xk7.ru/p/a/i              ##
;##                                              ##
;##################################################

IFDEF		??Version	; TASM
  LOCALS
ENDIF

IQSortS1_ver	=	100h			;    (word: 訩  - 楫 , 訩 - ஡)

; !!!   㫥 ᯮ  ࠢ 祭  ஢   ( 襣  襬)
; !!!     ࠢ  ஢   室  ᮮ⢥騥 樨, 祭   ᨬ ***

; IQSortInsThrs = ண ᯮ짮 ஢ ⠢ ( - ⮢  㪠  祭) [ 2;  㬮砭 16]
;   ᫨ - ⮢ ( ࢮ  ᫥饩 樨)   ࠢ 祭 IQSortInsThrs, ᯮ  ஢, 
;   ᯮ ஢ ⠢ -   ᪮  ( ࠢ쭮 롮 祭 IQSortInsThrs, ਬ,  祭  㬮砭)
;    㬥蠥 㡨 ४ᨨ,  ⥪  ९
IQSortInsThrs	=	16

; IQSortMaxStk = ᨬ ࠧ ⥪  ,  ⨬ ᯮ짮 楤 IQSort ( call  ᭮ ) [ 10;  㬮砭 128]
;    ஢  ᯮ 4  (2 ᫮) ⥪ ( ஢ -  4- ᫮, ᫥  ᯮ짮  1 ᫮ , ⮣  10 ),
;   .. 128   ࣠  30 ஢ ४ᨨ,  筮   祭  ᨢ
IQSortMaxStk	=	128

;-----------------------------------------------------------------------------------------------------------------------

;-- IQSort:    ᨢ (஢ ⮤) -------------------------------------------------
; > 室 : DS:DX =  ᨢ, CX = - ⮢ ᨢ ( 祭)
; > : ஢ ᨢ ( ⮬  )
;  ᨢ ᮤঠ  1 祭 ⨯ WORD,  ஬ ந室 ࠢ  ஢
; ᫨ - ⮢ ( ࢮ  ᫥饩 樨)   ࠢ 祭 IQSortInsThrs, ᯮ  ஢,
;    ᯮ ஢ ⠢
; ஢ ⠢ ⠪ ᯮ, ᫨  ᫥饣 ஢ ४ᨨ ॡ  IQSortMaxStk  ⥪  饬 ᫮
; 楤  ॣ AX, BX, CX, DX, SI, DI, ࠭ BP  ᥣ ॣ
IQSort		PROC
		dec	cx
		jle	@@exit			; 室, ᫨ - ⮢ <= 1

		push	bp
		xor	bp,bp			; BP = - ४ᨩ
		shl	cx,1
		add	cx,dx			; CX =  ᫥ 

		;  楤 ன ஢
		; DX =  ࢮ , CX =  ᫥ , CX > DX, BP = ஢ ४ᨨ
	@@IQSortMain:
		mov	ax,cx
		sub	ax,dx
		shr	ax,1			; AX = - ⮢  1
		cmp	ax,IQSortInsThrs-1
		jb	@@callins		; ᫨ - ⮢  ண 祭, ᯮ㥬 ஢ ⠢

		mov	si,dx			;; I (SI) := L (DX)
	@@repeat1:				;; repeat
		mov	di,cx			;; J (DI) := R (CX)
		mov	bx,cx
		sub	bx,dx
		shr	bx,1
		and	bx,-2
		add	bx,dx			;; P (BX) := (L + R) / 2
		mov	ax,[bx]			;; T (AX) := [P]
	@@repeat2 = @@cmpI			;; repeat
		; SI = I, AX = T, DI = J, DX = L, CX = R
		jmp	@@cmpI
	@@addI:	add	si,2			;; Inc(I)
	@@cmpI:	cmp	[si],ax			;; while [I] < T
		jl	@@addI			; {*** ஢  ⠭: jl -  ࠢ, jb - ;  뢠: jg - , ja - }

		jmp	@@cmpJ
	@@subJ:	sub	di,2			;; Dec(J)
	@@cmpJ:	cmp	[di],ax			;; while [J] > T
		jg	@@subJ			; {*** ஢  ⠭: jg -  ࠢ, ja - ;  뢠: jl - , jb - }

		cmp	si,di
		jnbe	@@noswap		;; if I <= J then

		mov	bx,[si]			;;   Swap [I],[J]
		xchg	[di],bx
		mov	[si],bx

		add	si,2			;; Inc(I)
		sub	di,2			;; Dec(J)
	@@noswap:
		cmp	si,di
		jna	@@repeat2		;; until I > J

		cmp	dx,di
		jnb	@@norecurs		;; if L < J then

		push	cx
		push	si			; ࠭塞 R  I
		mov	cx,di
		; DX = L, CX = J
		cmp	bp,(IQSortMaxStk-10)/4	; 5 ᫮ -     뢠 ணࠬ + bp + cx + si +    InsSort
		jae	@@callins2		; ᫨ ᫮ ४ᨩ ⨣ ᨬ㬠,   맮 ஢ ⠢: InsSort(L, J)
		inc	bp			;  㢥稢 㡨 ४ᨨ    ४
		jmp	@@IQSortMain		;;   IQSort(L, J); 맮  १ jmp   ⥪ :)
	@@recursret:
		pop	si
		pop	cx			; ⠭ I  R
	@@norecurs:
		mov	dx,si			;; L := I
		cmp	si,cx
		jnae	@@repeat1		;; until I >= R
	@@finish:
		dec	bp			; 㬥蠥 㡨 ४ᨨ
		jns	@@recursret		; 룠, ᫨    (୥) ஢ ४ᨨ
		pop	bp
	@@exit:	ret

	@@callins:
		push	offset @@finish		;  
		jmp	@IQInsSort		;  call + jmp @@finish  push + jmp
	@@callins2:
		push	offset @@recursret	;  
		jmp	@IQInsSort		;  call + jmp @@recursret  push + jmp
IQSort		ENDP

;-- InsSort:  ᨢ  ------------------------------------------------------------------------------
; > 室 : DS:DX =  ᨢ, CX = - ⮢ ᨢ ( 祭)
; > : ஢ ᨢ ( ⮬  )
;  ᨢ ᮤঠ  1 祭 ⨯ WORD,  ஬ ந室 ࠢ  ஢
; 楤  ॣ AX, BX, SI, DI, ࠭ CX, DX, BP  ᥣ ॣ
InsSort		PROC
		dec	cx
		jle	@@exit			; 室, ᫨ - ⮢ <= 1

		shl	cx,1
		add	cx,dx			; CX =  ᫥ 

		;  楤 ஢ ⠢
		; DX =  ࢮ , CX =  ᫥ , CX > DX
IFDEF		??Version	; TASM
  @IQInsSort:
ELSE				; MASM
  @IQInsSort::
ENDIF
		mov	di,dx			; J (DI) := L -  ࢮ 
	@@next:					;; for J (DI) := L+1 (CX) to R (DX) do
		add	di,2			; J++ (DI) -  ᫥饣 ஢塞  ( ᭮ 横)
		mov	bx,[di]			;; T (BX) := [J]
		mov	si,di			; I+1 (SI) := DI -  , ᫥饣  ࠢ ( ७ 横)
	@@loop:					;; repeat
		mov	ax,[si-2]
		cmp	ax,bx			;; if [I] > T then
		jle	@@break			; 룠, ᫨ [I] <= T {*** ஢  ⠭: jle -  ࠢ, jbe - ;  뢠: jge - , jae - }

		mov	[si],ax			;;  [I+1] := [I] else Break

		sub	si,2			;; Dec(I)
		cmp	si,dx
		jnbe	@@loop			;; until I < L (I+1 <= L)
	@@break:
		mov	[si],bx			;; [I+1] := T

		cmp	di,cx
		jnae	@@next			; ᫥騩  ᨢ ;; end for
	@@exit:	ret
InsSort		ENDP
